const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class BillsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const bills = await db.bills.create(
      {
        id: data.id || undefined,

        title: data.title || null,
        amount: data.amount || null,
        bill_month: data.bill_month || null,
        category: data.category || null,
        upload_url: data.upload_url || null,
        status: data.status || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await bills.setSchool(data.school || null, {
      transaction,
    });

    await bills.setSchools(data.schools || null, {
      transaction,
    });

    return bills;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const billsData = data.map((item, index) => ({
      id: item.id || undefined,

      title: item.title || null,
      amount: item.amount || null,
      bill_month: item.bill_month || null,
      category: item.category || null,
      upload_url: item.upload_url || null,
      status: item.status || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const bills = await db.bills.bulkCreate(billsData, { transaction });

    // For each item created, replace relation files

    return bills;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const bills = await db.bills.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.title !== undefined) updatePayload.title = data.title;

    if (data.amount !== undefined) updatePayload.amount = data.amount;

    if (data.bill_month !== undefined)
      updatePayload.bill_month = data.bill_month;

    if (data.category !== undefined) updatePayload.category = data.category;

    if (data.upload_url !== undefined)
      updatePayload.upload_url = data.upload_url;

    if (data.status !== undefined) updatePayload.status = data.status;

    updatePayload.updatedById = currentUser.id;

    await bills.update(updatePayload, { transaction });

    if (data.school !== undefined) {
      await bills.setSchool(
        data.school,

        { transaction },
      );
    }

    if (data.schools !== undefined) {
      await bills.setSchools(
        data.schools,

        { transaction },
      );
    }

    return bills;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const bills = await db.bills.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of bills) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of bills) {
        await record.destroy({ transaction });
      }
    });

    return bills;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const bills = await db.bills.findByPk(id, options);

    await bills.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await bills.destroy({
      transaction,
    });

    return bills;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const bills = await db.bills.findOne({ where }, { transaction });

    if (!bills) {
      return bills;
    }

    const output = bills.get({ plain: true });

    output.school = await bills.getSchool({
      transaction,
    });

    output.schools = await bills.getSchools({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userSchools = (user && user.schools?.id) || null;

    if (userSchools) {
      if (options?.currentUser?.schoolsId) {
        where.schoolsId = options.currentUser.schoolsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.schools,
        as: 'school',
      },

      {
        model: db.schools,
        as: 'schools',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.title) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('bills', 'title', filter.title),
        };
      }

      if (filter.bill_month) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('bills', 'bill_month', filter.bill_month),
        };
      }

      if (filter.category) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('bills', 'category', filter.category),
        };
      }

      if (filter.upload_url) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('bills', 'upload_url', filter.upload_url),
        };
      }

      if (filter.amountRange) {
        const [start, end] = filter.amountRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.school) {
        const listItems = filter.school.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          schoolId: { [Op.or]: listItems },
        };
      }

      if (filter.schools) {
        const listItems = filter.schools.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          schoolsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.schoolsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.bills.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('bills', 'title', query),
        ],
      };
    }

    const records = await db.bills.findAll({
      attributes: ['id', 'title'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['title', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.title,
    }));
  }
};
